//region Imports
var babelator = require('../config')()
var testsGlob = babelator.testsGlob
var srcGlob = babelator.srcGlob
//endregion

module.exports = function(wallaby) {
  return {
    debug: true,
    files: [
      srcGlob,
      {pattern: testsGlob, ignore: true},
    ],
    tests: [
      testsGlob
    ],
    compilers: {
      '**/*.js': wallaby.compilers.babel({
        babel: require('babel-core'),
        plugins: babelator.babel.plugins,
        presets: babelator.babel.presets,
      })
    },
    testFramework: 'mocha',
    env: {
      type: 'node',
      //runner: '/Users/Vaughan/nvm/versions/node/v0.12.7/bin/node',
      params: {
        runner: '--harmony',
      }
    },
    bootstrap: function() {
      var mocha = wallaby.testFramework
      var chai = require('chai')
      var chaiAsPromised = require('chai-as-promised')
      chai.use(chaiAsPromised)
      mocha.ui('bdd')
      expect = chai.expect
      var should = chai.should()
    },
  }
}
