function getModuleOpts(opts) {
  const cwd = require('cwd')
  const _ = require('lodash')

  const srcDir = cwd('modules')
  const destDir = 'lib-modules'

  // TODO(vjpr): This is very bad! We should make each task generic. Should export just functions.
  // Or this might be fine.
  opts = _.merge({}, opts, {
    srcGlob: srcDir + '/**/*.js',
    srcFilesGlob: srcDir + '/**/!(*.js|*.jsx)',
    destGlob: destDir + '/**/*',
    testsGlob: srcDir + '/**/__tests__/**/*-test.js',
    shouldCompileTests: false,
    babel: {}, // See src/config.
    srcDir,
    destDir,
    sourceMaps: false,
  })

  return opts

}

export default (gulp, opts) => {

  opts = getOpts(opts)

  gulp.task('flow-modules:check', (done) => {
    const {spawnSync} = require('child_process')

    // TODO(vjpr): Limit output to fit on screen to allow user to work through errors from first to last.
    spawnSync('flow', ['status', '--no-auto-start'], {stdio: 'inherit'})
    done()
  })

  gulp.task('flow-modules:watch', gulp.series('flow-modules:check', function watcher() {
    const gutil = require('gulp-util')

    // Used by `compile` task to check whether we should only compile changed files.
    gulp.isWatching = true

    // Sometimes we might want to use src, sometimes something else.
    gulp.watch(opts.srcGlob, gulp.series('flow-modules:check')).on('change', (evt) => {
      gutil.log('---')
      gutil.log('File changed:', gutil.colors.red(evt.path))
    })

  }))

  // TODO(vjpr): Do.
  //gulp.task('flow:bootstrap')

}

const flowConfig = ''
